//+------------------------------------------------------------------+
//|                                                   #MainTrend.mq4 |
//|                                       Copyright 2012, Golestanfx |
//|                                             Golestanfx@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Golestanfx"
#property link      "Golestanfx@yahoo.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 10
#property indicator_buffers 2

#property indicator_color1  Green
#property indicator_color2  Red


#property indicator_width1 0
#property indicator_width2 0




//---- input parameters
extern double  Level      =5;
extern int     MA_Price   =0; //Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
extern int     MA_Length  =1; //MA's Period 
extern int     MA_Mode    =0; //MA's Method:0-SMA,1-EMA,2-SMMA,3-LWMA  
extern int     ATR_Length =10;//ATR's Period
extern double  Kv         =4; //Volatility's Factor or Multiplier
extern double  MoneyRisk  =1; //Offset Factor 
extern int     TimeFrame = 0;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 


double Bullish[];
double Bearish[];
double trend[];


//string short_name = "#MainTrend";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   IndicatorDigits(1);
  // IndicatorShortName(short_name);
   

   SetIndexBuffer(0, Bullish);
   SetIndexBuffer(1, Bearish);
   SetIndexBuffer(2, trend);
   
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);

   SetIndexLabel(0, "Bullish");
   SetIndexLabel(1, "Bearish");
   
   SetIndexArrow(0, 167);
   SetIndexArrow(1, 167);


   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
 {
  int counted_bars = IndicatorCounted();
  if(counted_bars > 0) counted_bars--;
  int Limit = Bars - counted_bars;

for(int i=Limit; i>=0; i--)
 {
  double UP1 = iCustom(NULL, 0, "volty3", MA_Price, MA_Length, MA_Mode, ATR_Length, Kv, MoneyRisk, TimeFrame, 0, i);
  
  double DN1 = iCustom(NULL, 0, "volty3", MA_Price, MA_Length, MA_Mode, ATR_Length, Kv, MoneyRisk, TimeFrame, 1, i);
  
  double UP2 = iCustom(NULL, 0, "volty3", MA_Price, MA_Length, MA_Mode, ATR_Length, Kv, MoneyRisk, TimeFrame, 2, i);
 
  double DN2 = iCustom(NULL, 0, "volty3", MA_Price, MA_Length, MA_Mode, ATR_Length, Kv, MoneyRisk, TimeFrame, 3, i);
  

  


//---------------------------------------------


  trend[i]=trend[i+1];
  if(DN1 == EMPTY_VALUE && DN2 == EMPTY_VALUE) { Bullish[i] = Level; trend[i]= 1; }
  if(UP1 == EMPTY_VALUE && UP2 == EMPTY_VALUE) { Bearish[i] = Level; trend[i]=-1; }
  
  }
  manageAlerts();
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",TimeFrame+" MainTrend ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MainTrend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


